//Draws a vertical line down the screen
void DrawVLine (long x1, long y1, long y2, long c)
{
  char *o = (char *)SurfaceDesc.lpSurface + Lines [y1] + Columns [x1];
  //For every pixel along the line
  for (x1 = y1; x1 < y2; x1++) {
    //Set pixel and move down one
    memcpy (o, &c, Bpp);
    o += SurfaceDesc.lPitch;
  }
}

//Casts a ray from specified position and renders result
void Ray (float a, unsigned short tx, unsigned short ty, long sX)
{
  unsigned short    deltax = (unsigned short)(cos (a) * 256.0f);
  unsigned short    deltay = (unsigned short)(sin (a) * 256.0f);
  long              minY = Mode->y;
  float             d = 0;

  do {
    //Update position, in range
    tx += deltax;
    ty += deltay;
    //New distance
    d += 1.0f;
    //Calculate offset into map
    long o = (ty & 0xFF00) + (tx >> 8);
    long h = Height_Bitmap [o] - Height;
    //Calculate height
    long y1 = (DComp1 - (h << DComp3));
    y1 /= (long)d;
    y1 += DComp2;
    if (y1 < minY) {
      //Draw voxel
      if (y1 < 0) y1 = 0;
      DrawVLine (sX, y1, minY, Colour_Bitmap [o]);
      minY = y1;
      if (minY <= 0) return;
    }
  } while (d < 0x40);
}

void DrawView ()
{
  //Lock DD surface
  DDBack->Lock (NULL, &SurfaceDesc, DDLOCK_WAIT | DDLOCK_SURFACEMEMORYPTR, NULL);

  //Clear screen
  memset ((char *)SurfaceDesc.lpSurface, 0, Lines [Mode->y - 1]);

  //Fill every column on-screen
  for (long i = 0; i < Mode->x; i++) {
    //Calculate ray angle depending on view angle
    float a = Angle + (float)i / Mode->x - 0.5f;
    Ray (a, x, y, i);
  }

  //Unlock and display DD surface
  DDBack->Unlock (SurfaceDesc.lpSurface);
  if (DDPrimary->Flip (NULL, DDFLIP_WAIT) == DDERR_SURFACELOST) DDPrimary->Restore();
}
