//Window handler
long WINAPI WindowMessageHandler (HWND hWnd, UINT wMessage, WPARAM wParam, LPARAM lParam)
{
  //Press start button
  if (wMessage == WM_COMMAND && (HWND)lParam == ButtonHandle) Status = 2;
  //Close window
  if (wMessage == WM_CLOSE) Status = 4;
  //Other messages
  return DefWindowProc (hWnd, wMessage, wParam, lParam);
}


//Registers a new window class and creates an empty window.
void InitWindow ()
{
  //For initializing the window
  WNDCLASS      wndclass;

  //Register window class, as standard as can be
  wndclass.style = 0;
  wndclass.lpfnWndProc = (WNDPROC)WindowMessageHandler;
  wndclass.cbClsExtra = 0;
  wndclass.cbWndExtra = 0;
  wndclass.hInstance = InstanceHandle;
  wndclass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  wndclass.hCursor = LoadCursor(NULL, IDC_ARROW);
  wndclass.hbrBackground = (HBRUSH)COLOR_BACKGROUND + 1;
  wndclass.lpszMenuName = NULL;
  wndclass.lpszClassName = (LPSTR)"VOXELS";
  RegisterClass (&wndclass);
}

//Creates a window for the menu
void InitMenuWindow ()
{
  //Create empty window
  WindowHandle = CreateWindow ("VOXELS", "DirectX Voxels", WS_OVERLAPPED | WS_VISIBLE | WS_SYSMENU, CW_USEDEFAULT, CW_USEDEFAULT, 320, 88, NULL, NULL, InstanceHandle, NULL);

  //Create combo box
  BoxHandle = CreateWindowEx (NULL, "COMBOBOX", "", WS_BORDER | WS_CHILD | WS_VISIBLE | WS_VSCROLL | CBS_DROPDOWNLIST, 4, 4, 308, 112, WindowHandle, NULL, InstanceHandle, NULL);
  for (int Mode = 0; Mode < NumModes; Mode++) {
    char Text [100];
    sprintf (Text, "%dx%d, %dbit", Modes [Mode].x, Modes [Mode].y, Modes [Mode].pf.dwRGBBitCount);
    SendMessage (BoxHandle, CB_ADDSTRING, 0, (LPARAM)Text);
  }
  SendMessage (BoxHandle, CB_SETCURSEL, 0, NULL);

  //Create button
  ButtonHandle = CreateWindowEx (NULL, "BUTTON", "Start!", WS_CHILD | WS_VISIBLE, 4, 32, 308, 24, WindowHandle, NULL, InstanceHandle, NULL);

  //Display the window
  ShowWindow (WindowHandle, SW_SHOWNORMAL);
}

//Creates a window for the game
void InitGameWindow ()
{
  //Create empty window
  WindowHandle = CreateWindow ("VOXELS", "DirectX Voxels", WS_POPUP, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, InstanceHandle, NULL);

  //Display the window
  ShowWindow (WindowHandle, SW_SHOWNORMAL);
}